//+------------------------------------------------------------------+
//|                                               SuperTrend nrp.mq4 |
//|                                                                  |
//| original Super trend for metatrader made by Jason Robinson       |
//| calculation correction, repainting solving and mtf by mladen     |
//+------------------------------------------------------------------+
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"

#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1  clrLimeGreen
#property indicator_color2  clrRed
#property indicator_width1  4
#property indicator_width2  4
#property indicator_maximum 1
#property indicator_minimum 0

//
//
//
//
//

extern ENUM_TIMEFRAMES    TimeFrame          = PERIOD_CURRENT;
extern int                atrPeriod          = 60;
extern double             atrMultiplier      = 2.00;
extern bool               alertsOn           = true;        // Turn alerts on
extern bool               alertsOnCurrent    = true;        // Alerts on current (still opened) bar
extern bool               alertsMessage      = true;        // Alerts should display alert message
extern bool               alertsNotification = false;       // Alerts should send alert notification
extern bool               alertsSound        = false;       // Alerts should play alert sound
extern bool               alertsEmail        = false;       // Alerts should send alert email?

//
//
//
//
//

double Trend[];
double TrendDa[];
double TrendDb[];
double Up[];
double Dn[];
double Direction[];
string indicatorFileName;
bool   returnBars;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
      IndicatorBuffers(6);
      SetIndexBuffer(0, TrendDa);  SetIndexStyle(0, DRAW_HISTOGRAM);
      SetIndexBuffer(1, TrendDb);  SetIndexStyle(1, DRAW_HISTOGRAM);
      SetIndexBuffer(2, Trend); 
      SetIndexBuffer(3, Up);
      SetIndexBuffer(4, Dn);
      SetIndexBuffer(5, Direction);

      //
      //
      //
      //
      //
      
         indicatorFileName = WindowExpertName();
         returnBars        = TimeFrame==-99;
         TimeFrame         = MathMax(TimeFrame,_Period);
   
      //
      //
      //
      //
      //

   IndicatorShortName(timeFrameToString(TimeFrame)+" xSuperTrend");
return(0);
}

int deinit() {  return(0); }

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   int counted_bars = IndicatorCounted();
   int limit,i;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);
         if (returnBars) { TrendDa[0] = limit+1; return(0); }
  
   //
   //
   //
   //
   //

   if (TimeFrame==Period())
   {      
      for(i=limit; i>=0; i--)
      {
         double atr    = iATR(NULL,0,atrPeriod,i);
         double cprice = Close[i];
         double mprice = iMA(NULL,0,1,0,MODE_SMA,PRICE_MEDIAN,i);
                Up[i]  = mprice+atrMultiplier*atr;
                Dn[i]  = mprice-atrMultiplier*atr;
         
         //
         //
         //
         //
         //

         TrendDa[i] = EMPTY_VALUE;
         TrendDb[i] = EMPTY_VALUE;
         Direction[i] = Direction[i+1];
            if (cprice > Up[i+1]) Direction[i] =  1;
            if (cprice < Dn[i+1]) Direction[i] = -1;
            if (Direction[i] > 0) { Dn[i] = MathMax(Dn[i],Dn[i+1]); Trend[i] = Dn[i]; }
            else                  { Up[i] = MathMin(Up[i],Up[i+1]); Trend[i] = Up[i]; }
            if (Direction[i]== 1) TrendDa[i] = 1;
            if (Direction[i]==-1) TrendDb[i] = 1;
            
     
            
      }
      
      if (alertsOn)
      {
         int whichBar = 1; if (alertsOnCurrent) whichBar = 0;
         if (Direction[whichBar] != Direction[whichBar+1])
         if (Direction[whichBar] == 1)
               doAlert("up");
         else  doAlert("down");          
      }   
      return(0);
   }

   //
   //
   //
   //
   //
   
   limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,TimeFrame,indicatorFileName,-99,0,0)*TimeFrame/Period()));
   for (i=limit;i>=0;i--)
   {
      int y = iBarShift(NULL,TimeFrame,Time[i]);
         TrendDa[i] = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,atrPeriod,atrMultiplier,alertsOn,alertsOnCurrent,alertsMessage,alertsNotification,alertsSound,alertsEmail,0,y);
         TrendDb[i] = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,atrPeriod,atrMultiplier,alertsOn,alertsOnCurrent,alertsMessage,alertsNotification,alertsSound,alertsEmail,1,y);
   }
return(0);
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//

void doAlert(string doIt)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doIt || previousTime != Time[0]) {
          previousAlert  = doIt;
          previousTime   = Time[0];
          
       //
       //
       //
       //
       //

       message =  StringConcatenate(Symbol()," ",timeFrameToString(_Period)," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," xSuperTrend ",doIt);
          if (alertsMessage)      Alert(message);
          if (alertsNotification) SendNotification(message);
          if (alertsEmail)        SendMail(StringConcatenate(Symbol()," xSuperTrend "),message);
          if (alertsSound)        PlaySound("alert2.wav");
   }
}

